/* Project     : zpc.pm
   Description : (null)
*/

constant

 hd_max : 2;
 ram_max : 4;

type

 Unit : [unit
];
 Undef : Unit;
 State : ["{state}Not on stock"
| "{state}On stock"
];
 Cputype : ["{cputype}Unknown"
| "{cputype}Slot A"
| "{cputype}Slot 1"
| "{cputype}Slot 2"
| "{cputype}FC-PGA"
| "{cputype}Socket A"
| "{cputype}Socket 7"
| "{cputype}Socket 423"
| "{cputype}MMC1"
];
 Ramtype : ["{ramtype}-"
| "{ramtype}32-bit EDO"
| "{ramtype}SDRAM"
| "{ramtype}DDR-SDRAM"
| "{ramtype}RDRAM"
];
 Capability : ["{capability}Poor"
| "{capability}Medium"
| "{capability}Good"
];
 Ramnums : ["{ramnums}0"
| "{ramnums}1"
| "{ramnums}2"
| "{ramnums}3"
| "{ramnums}4"
];
 Ramcapacity : ["0 Mb"
| "32 Mb"
| "64 Mb"
| "92 Mb"
| "128 Mb"
| "160 Mb"
| "192 Mb"
| "224 Mb"
| "256 Mb"
| "288 Mb"
| "320 Mb"
| "352 Mb"
| "384 Mb"
| "416 Mb"
| "448 Mb"
| "480 Mb"
| "512 Mb"
| "544 Mb"
| "576 Mb"
| "608 Mb"
| "640 Mb"
| "672 Mb"
| "704 Mb"
| "736 Mb"
| "768 Mb"
| "800 Mb"
| "832 Mb"
| "864 Mb"
| "896 Mb"
| "928 Mb"
| "960 Mb"
| "992 Mb"
| "1024 Mb"
| "1056 Mb"
| "1088 Mb"
| "1120 Mb"
| "1152 Mb"
| "1184 Mb"
| "1216 Mb"
| "1248 Mb"
| "1280 Mb"
| "1312 Mb"
| "1344 Mb"
| "1376 Mb"
| "1408 Mb"
| "1440 Mb"
| "1472 Mb"
| "1504 Mb"
| "1536 Mb"
| "1568 Mb"
| "1600 Mb"
| "1632 Mb"
| "1664 Mb"
| "1696 Mb"
| "1728 Mb"
| "1760 Mb"
| "1792 Mb"
| "1824 Mb"
| "1856 Mb"
| "1888 Mb"
| "1920 Mb"
| "1952 Mb"
| "1984 Mb"
| "2016 Mb"
| "2048 Mb"
];
 Speed : ["66 MHz"
| "133 MHz"
| "200 MHz"
| "233 MHz"
| "266 MHz"
| "366 MHz"
| "450 MHz"
| "500 MHz"
| "550 MHz"
| "600 MHz"
| "733 MHz"
| "750 MHz"
| "766 MHz"
| "800 MHz"
| "850 MHz"
| "866 MHz"
| "900 MHz"
| "933 MHz"
| "950 MHz"
| "1000 MHz"
| "1100 MHz"
| "1130 MHz"
| "1200 MHz"
| "1400 MHz"
| "1500 MHz"
];
 Formfactor : [ATX
| uATX
| AT
];
 Mb : {
private  id : ["350283"
| "350119"
| "350159"
| "350251"
| "350219"
| "350216"
| "350266"
| "350245"
| "350243"
| "350208"
| "350223"
| "350185"
| "350227"
| "350226"
| "350268"
| "350239"
| "350229"
];
private state : State;
public  brandmodel : ["{pc.mb.brandmodel}Asus A7V"
| "{pc.mb.brandmodel}Asus CUSL2-C"
| "{pc.mb.brandmodel}GigaByte GA-5AX"
| "{pc.mb.brandmodel}GigaByte GA-6OMM7E"
| "{pc.mb.brandmodel}GigaByte GA-6OMM7E-1"
| "{pc.mb.brandmodel}GigaByte GA-6VA7+"
| "{pc.mb.brandmodel}GigaByte GA-6VXC7+"
| "{pc.mb.brandmodel}GigaByte GA-7IXE"
| "{pc.mb.brandmodel}GigaByte GA-7ZX-1"
| "{pc.mb.brandmodel}GigaByte GA-8TX"
| "{pc.mb.brandmodel}Intel D815EEAAL"
| "{pc.mb.brandmodel}IWill KA266"
| "{pc.mb.brandmodel}No name 807LR"
| "{pc.mb.brandmodel}No name M754LMR"
| "{pc.mb.brandmodel}SuperMicro P6DGE"
| "{pc.mb.brandmodel}SuperMicro P6DGU"
| "{pc.mb.brandmodel}SuperMicro P6SBU"
];
private cputype : Cputype;
private ramnums : Ramnums;
private ramtype : Ramtype;
private net : boolean;
private sound : boolean;
private speed_min : Speed;
private speed_max : Speed;
private formfactor : Formfactor;
private scsionboard : ["{pc.mb.scsionboard}0"
| "{pc.mb.scsionboard}1"
];
private gconboard : ["{pc.mb.gconboard}0"
| "{pc.mb.gconboard}1"
];
private soundonboard : ["{pc.mb.soundonboard}0"
| "{pc.mb.soundonboard}1"
];
private netonboard : ["{pc.mb.netonboard}0"
| "{pc.mb.netonboard}1"
];
rule
((id = "350283") and (state = "{state}On stock") and (cputype = "{cputype}FC-PGA") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-6VA7+") and (formfactor = AT) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "66 MHz") and (speed_max = "133 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350119") and (state = "{state}On stock") and (cputype = "{cputype}Socket 7") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-5AX") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "133 MHz") and (speed_max = "500 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350159") and (state = "{state}On stock") and (cputype = "{cputype}Slot A") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-7IXE") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "500 MHz") and (speed_max = "850 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350251") and (state = "{state}On stock") and (cputype = "{cputype}Socket A") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}2") and (brandmodel = "{pc.mb.brandmodel}No name 807LR") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}1") and (speed_min = "500 MHz") and (speed_max = "1130 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350219") and (state = "{state}On stock") and (cputype = "{cputype}Socket A") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-7ZX-1") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "500 MHz") and (speed_max = "1200 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350216") and (state = "{state}On stock") and (cputype = "{cputype}Socket A") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}Asus A7V") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "550 MHz") and (speed_max = "1200 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350266") and (state = "{state}On stock") and (cputype = "{cputype}Socket A") and (ramtype = "{ramtype}DDR-SDRAM") and (ramnums = "{ramnums}4") and (brandmodel = "{pc.mb.brandmodel}IWill KA266") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}1") and (speed_min = "600 MHz") and (speed_max = "1200 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350245") and (state = "{state}Not on stock") and (cputype = "{cputype}Slot 1") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}4") and (brandmodel = "{pc.mb.brandmodel}SuperMicro P6SBU") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}1") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "233 MHz") and (speed_max = "850 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350243") and (state = "{state}On stock") and (cputype = "{cputype}Slot 1") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}4") and (brandmodel = "{pc.mb.brandmodel}SuperMicro P6DGE") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "233 MHz") and (speed_max = "850 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350208") and (state = "{state}On stock") and (cputype = "{cputype}Slot 1") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}4") and (brandmodel = "{pc.mb.brandmodel}SuperMicro P6DGU") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}1") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "233 MHz") and (speed_max = "850 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350223") and (state = "{state}On stock") and (cputype = "{cputype}FC-PGA") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-6VXC7+") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "200 MHz") and (speed_max = "1400 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350185") and (state = "{state}On stock") and (cputype = "{cputype}FC-PGA") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}2") and (brandmodel = "{pc.mb.brandmodel}No name M754LMR") and (formfactor = uATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}1") and (speed_min = "266 MHz") and (speed_max = "800 MHz") and (gconboard = "{pc.mb.gconboard}1") and (netonboard = "{pc.mb.netonboard}1"))
 or 
((id = "350227") and (state = "{state}On stock") and (cputype = "{cputype}FC-PGA") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-6OMM7E") and (formfactor = uATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}1") and (speed_min = "66 MHz") and (speed_max = "1500 MHz") and (gconboard = "{pc.mb.gconboard}1") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350226") and (state = "{state}On stock") and (cputype = "{cputype}FC-PGA") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-6OMM7E-1") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "66 MHz") and (speed_max = "1500 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350268") and (state = "{state}On stock") and (cputype = "{cputype}FC-PGA") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}Asus CUSL2-C") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}0") and (speed_min = "450 MHz") and (speed_max = "1000 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
 or 
((id = "350239") and (state = "{state}On stock") and (cputype = "{cputype}FC-PGA") and (ramtype = "{ramtype}SDRAM") and (ramnums = "{ramnums}3") and (brandmodel = "{pc.mb.brandmodel}Intel D815EEAAL") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}1") and (speed_min = "500 MHz") and (speed_max = "1000 MHz") and (gconboard = "{pc.mb.gconboard}1") and (netonboard = "{pc.mb.netonboard}1"))
 or 
((id = "350229") and (state = "{state}On stock") and (cputype = "{cputype}Socket 423") and (ramtype = "{ramtype}RDRAM") and (ramnums = "{ramnums}4") and (brandmodel = "{pc.mb.brandmodel}GigaByte GA-8TX") and (formfactor = ATX) and (scsionboard = "{pc.mb.scsionboard}0") and (soundonboard = "{pc.mb.soundonboard}1") and (speed_min = "66 MHz") and (speed_max = "1500 MHz") and (gconboard = "{pc.mb.gconboard}0") and (netonboard = "{pc.mb.netonboard}0"))
;
(sound <-> (soundonboard = "{pc.mb.soundonboard}1"));
(net <-> (netonboard = "{pc.mb.netonboard}1"));
};
 Cpu : {
private  id : ["150107"
| "150338"
| "150339"
| "150340"
| "150363"
| "150364"
| "150365"
| "150366"
| "150367"
| "150801"
| "150803"
| "150501"
| "150503"
| "150248"
| "150236"
| "150247"
| "150253"
| "150601"
| "150602"
| "150042"
| "150106"
| "150270"
];
private state : State;
public  brandmodel : ["{pc.cpu.brandmodel}AMD Athlon-C"
| "{pc.cpu.brandmodel}AMD Duron"
| "{pc.cpu.brandmodel}AMD K6-2"
| "{pc.cpu.brandmodel}AMD New Athlon"
| "{pc.cpu.brandmodel}Intel Celeron"
| "{pc.cpu.brandmodel}Intel Pentium 4"
| "{pc.cpu.brandmodel}Intel Pentium II - Xeon"
| "{pc.cpu.brandmodel}Intel Pentium III"
| "{pc.cpu.brandmodel}Intel Pentium III - Xeon"
];
public  speed : Speed;
private cputype : Cputype;
rule
((id = "150107") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}AMD K6-2") and (speed = "500 MHz") and (cputype = "{cputype}Socket 7"))
 or 
((id = "150338") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}AMD Duron") and (speed = "750 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150339") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}AMD Duron") and (speed = "800 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150340") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}AMD Duron") and (speed = "850 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150363") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}AMD New Athlon") and (speed = "900 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150364") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}AMD New Athlon") and (speed = "950 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150365") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}AMD New Athlon") and (speed = "1000 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150366") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}AMD New Athlon") and (speed = "1100 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150367") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}AMD New Athlon") and (speed = "1200 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150801") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}AMD Athlon-C") and (speed = "1000 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150803") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}AMD Athlon-C") and (speed = "1200 MHz") and (cputype = "{cputype}Socket A"))
 or 
((id = "150501") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Celeron") and (speed = "733 MHz") and (cputype = "{cputype}FC-PGA"))
 or 
((id = "150503") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Celeron") and (speed = "800 MHz") and (cputype = "{cputype}FC-PGA"))
 or 
((id = "150248") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium III") and (speed = "850 MHz") and (cputype = "{cputype}FC-PGA"))
 or 
((id = "150236") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium III") and (speed = "866 MHz") and (cputype = "{cputype}FC-PGA"))
 or 
((id = "150247") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium III") and (speed = "933 MHz") and (cputype = "{cputype}FC-PGA"))
 or 
((id = "150253") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium III") and (speed = "1000 MHz") and (cputype = "{cputype}FC-PGA"))
 or 
((id = "150601") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium 4") and (speed = "1400 MHz") and (cputype = "{cputype}Socket 423"))
 or 
((id = "150602") and (state = "{state}Not on stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium 4") and (speed = "1500 MHz") and (cputype = "{cputype}Socket 423"))
 or 
((id = "150042") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium II - Xeon") and (speed = "450 MHz") and (cputype = "{cputype}Slot 2"))
 or 
((id = "150106") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium III - Xeon") and (speed = "550 MHz") and (cputype = "{cputype}Slot 2"))
 or 
((id = "150270") and (state = "{state}On stock") and (brandmodel = "{pc.cpu.brandmodel}Intel Pentium III - Xeon") and (speed = "600 MHz") and (cputype = "{cputype}Slot 2"))
;
};
 Ram : {
private  id : ["1000003"
| "240020"
| "240021"
| "240123"
| "240138"
| "240081"
| "240122"
| "240160"
| "240196"
| "240023"
| "249903"
| "240019"
| "240018"
| "240182"
| "240174"
| "240190"
| "240191"
| "240192"
| "240130"
| "240187"
| "243003"
| "243001"
| "243002"
| "242497"
| "240005"
];
public state : State;
public speed : ["{pc.ram.speed}-"
| "{pc.ram.speed}60 ns"
| "{pc.ram.speed}PC100"
| "{pc.ram.speed}PC133"
| "{pc.ram.speed}PC150"
| "{pc.ram.speed}PC800"
| "{pc.ram.speed}PC1600"
| "{pc.ram.speed}PC2100"
| "{pc.ram.speed}PC100, ECC"
| "{pc.ram.speed}PC133, ECC"
| "{pc.ram.speed}PC800, ECC"
];
public capacity : Ramcapacity;
public ramtype : Ramtype;
rule
((id = "1000003") and (state = "{state}On stock") and (speed = "{pc.ram.speed}-") and (ramtype = "{ramtype}-") and (capacity = "0 Mb"))
 or 
((id = "240020") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC100") and (ramtype = "{ramtype}SDRAM") and (capacity = "64 Mb"))
 or 
((id = "240021") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC100") and (ramtype = "{ramtype}SDRAM") and (capacity = "128 Mb"))
 or 
((id = "240123") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC100") and (ramtype = "{ramtype}SDRAM") and (capacity = "256 Mb"))
 or 
((id = "240138") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC100") and (ramtype = "{ramtype}SDRAM") and (capacity = "512 Mb"))
 or 
((id = "240081") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC133") and (ramtype = "{ramtype}SDRAM") and (capacity = "64 Mb"))
 or 
((id = "240122") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC133") and (ramtype = "{ramtype}SDRAM") and (capacity = "128 Mb"))
 or 
((id = "240160") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC133") and (ramtype = "{ramtype}SDRAM") and (capacity = "256 Mb"))
 or 
((id = "240196") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC133") and (ramtype = "{ramtype}SDRAM") and (capacity = "512 Mb"))
 or 
((id = "240023") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC100, ECC") and (ramtype = "{ramtype}SDRAM") and (capacity = "64 Mb"))
 or 
((id = "249903") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC100, ECC") and (ramtype = "{ramtype}SDRAM") and (capacity = "128 Mb"))
 or 
((id = "240019") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC133, ECC") and (ramtype = "{ramtype}SDRAM") and (capacity = "128 Mb"))
 or 
((id = "240018") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC133, ECC") and (ramtype = "{ramtype}SDRAM") and (capacity = "256 Mb"))
 or 
((id = "240182") and (state = "{state}Not on stock") and (speed = "{pc.ram.speed}PC133, ECC") and (ramtype = "{ramtype}SDRAM") and (capacity = "512 Mb"))
 or 
((id = "240174") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC150") and (ramtype = "{ramtype}SDRAM") and (capacity = "128 Mb"))
 or 
((id = "240190") and (state = "{state}Not on stock") and (speed = "{pc.ram.speed}PC800") and (ramtype = "{ramtype}RDRAM") and (capacity = "64 Mb"))
 or 
((id = "240191") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC800") and (ramtype = "{ramtype}RDRAM") and (capacity = "128 Mb"))
 or 
((id = "240192") and (state = "{state}Not on stock") and (speed = "{pc.ram.speed}PC800") and (ramtype = "{ramtype}RDRAM") and (capacity = "256 Mb"))
 or 
((id = "240130") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC800, ECC") and (ramtype = "{ramtype}RDRAM") and (capacity = "128 Mb"))
 or 
((id = "240187") and (state = "{state}Not on stock") and (speed = "{pc.ram.speed}PC800, ECC") and (ramtype = "{ramtype}RDRAM") and (capacity = "256 Mb"))
 or 
((id = "243003") and (state = "{state}Not on stock") and (speed = "{pc.ram.speed}PC1600") and (ramtype = "{ramtype}DDR-SDRAM") and (capacity = "64 Mb"))
 or 
((id = "243001") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC2100") and (ramtype = "{ramtype}DDR-SDRAM") and (capacity = "128 Mb"))
 or 
((id = "243002") and (state = "{state}On stock") and (speed = "{pc.ram.speed}PC2100") and (ramtype = "{ramtype}DDR-SDRAM") and (capacity = "256 Mb"))
 or 
((id = "242497") and (state = "{state}On stock") and (speed = "{pc.ram.speed}60 ns") and (ramtype = "{ramtype}32-bit EDO") and (capacity = "32 Mb"))
 or 
((id = "240005") and (state = "{state}Not on stock") and (speed = "{pc.ram.speed}60 ns") and (ramtype = "{ramtype}32-bit EDO") and (capacity = "64 Mb"))
;
};
 Hd : {
private  id : ["1000004"
| "210424"
| "210425"
| "210426"
| "210427"
| "210429"
| "210430"
| "210431"
| "210432"
| "210433"
| "210501"
| "210502"
| "210503"
| "210505"
| "210507"
| "210509"
| "210511"
| "210506"
| "210512"
| "211004"
| "211005"
| "211006"
| "210287"
| "210286"
| "210298"
| "210295"
| "210296"
| "210297"
| "210611"
| "210614"
| "210706"
| "210708"
| "210710"
| "210707"
| "210709"
| "210711"
| "210905"
| "210904"
| "210906"
];
private state : State;
public  brand : ["- None -"
| Hitachi
| IBM
| Maxtor
| Quantum
| Seagate
];
public  capacity : ["N/A"
| "9"
| "10"
| "15"
| "18"
| "20"
| "30"
| "36"
| "40"
| "60"
| "73"
| "75"
| "80"
| "81"
];
public  hdtype : ["{pc.hd.hdtype}ide"
| "{pc.hd.hdtype}scsi"
];
rule
((id = "1000004") and (state = "{state}On stock") and (brand = "- None -") and (capacity = "N/A") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210424") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "10") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210425") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "20") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210430") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "20") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210431") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "30") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210432") and (state = "{state}Not on stock") and (brand = Quantum) and (capacity = "40") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210433") and (state = "{state}Not on stock") and (brand = Quantum) and (capacity = "60") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210501") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "9") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210502") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "18") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210507") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "18") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210509") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "36") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210506") and (state = "{state}On stock") and (brand = Quantum) and (capacity = "9") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210512") and (state = "{state}Not on stock") and (brand = Quantum) and (capacity = "73") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "211004") and (state = "{state}On stock") and (brand = Seagate) and (capacity = "20") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "211005") and (state = "{state}Not on stock") and (brand = Seagate) and (capacity = "30") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "211006") and (state = "{state}On stock") and (brand = Seagate) and (capacity = "40") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210287") and (state = "{state}On stock") and (brand = Maxtor) and (capacity = "20") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210286") and (state = "{state}On stock") and (brand = Maxtor) and (capacity = "30") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210298") and (state = "{state}Not on stock") and (brand = Maxtor) and (capacity = "40") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210295") and (state = "{state}On stock") and (brand = Maxtor) and (capacity = "81") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210296") and (state = "{state}Not on stock") and (brand = Maxtor) and (capacity = "40") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210297") and (state = "{state}Not on stock") and (brand = Maxtor) and (capacity = "80") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210611") and (state = "{state}On stock") and (brand = IBM) and (capacity = "30") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210614") and (state = "{state}On stock") and (brand = IBM) and (capacity = "75") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210707") and (state = "{state}On stock") and (brand = IBM) and (capacity = "9") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210709") and (state = "{state}On stock") and (brand = IBM) and (capacity = "18") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210711") and (state = "{state}On stock") and (brand = IBM) and (capacity = "36") and (hdtype = "{pc.hd.hdtype}scsi"))
 or 
((id = "210905") and (state = "{state}On stock") and (brand = Hitachi) and (capacity = "10") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210904") and (state = "{state}Not on stock") and (brand = Hitachi) and (capacity = "15") and (hdtype = "{pc.hd.hdtype}ide"))
 or 
((id = "210906") and (state = "{state}On stock") and (brand = Hitachi) and (capacity = "20") and (hdtype = "{pc.hd.hdtype}ide"))
;
};
 Scsictrl : {
private  id : ["1000005"
| "160065"
| "160080"
| "160034"
| "160047"
| "160033"
| "160064"
| "160058"
| "230087"
| "230086"
| "160082"
| "351004"
| "160045"
| "160059"
| "160078"
| "160063"
| "160084"
| "160085"
];
private state : State;
public  description : ["{pc.scsictrl.description}- None -"
| "{pc.scsictrl.description}Adaptec 19160 Kit"
| "{pc.scsictrl.description}Adaptec 29160 Kit"
| "{pc.scsictrl.description}Adaptec 2930U Kit"
| "{pc.scsictrl.description}Adaptec 3200S"
| "{pc.scsictrl.description}Adaptec 3400S"
| "{pc.scsictrl.description}Adaptec 39160 Kit"
| "{pc.scsictrl.description}Adaptec Ultra DMA/66 RAID"
| "{pc.scsictrl.description}AMI MegaRAID Express 500"
| "{pc.scsictrl.description}Promise FastTrak 100"
| "{pc.scsictrl.description}Promise Ultra DMA/100"
| "{pc.scsictrl.description}SIDE-2930C"
| "{pc.scsictrl.description}SIDE-2935LVD"
| "{pc.scsictrl.description}SIDE-2936UW"
| "{pc.scsictrl.description}SIDE-DU 280"
| "{pc.scsictrl.description}SIDE-DU3160"
| "{pc.scsictrl.description}SIDE-RAID100"
| "{pc.scsictrl.description}SIDE-RAID66"
];
rule
((id = "1000005") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}- None -"))
 or 
((id = "160065") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}SIDE-RAID66"))
 or 
((id = "160080") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}SIDE-RAID100"))
 or 
((id = "160034") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}SIDE-2930C"))
 or 
((id = "160047") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}SIDE-2936UW"))
 or 
((id = "160033") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}SIDE-2935LVD"))
 or 
((id = "160064") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}SIDE-DU 280"))
 or 
((id = "160058") and (state = "{state}Not on stock") and (description = "{pc.scsictrl.description}SIDE-DU3160"))
 or 
((id = "230087") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}Promise Ultra DMA/100"))
 or 
((id = "230086") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}Promise FastTrak 100"))
 or 
((id = "160082") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}AMI MegaRAID Express 500"))
 or 
((id = "351004") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}Adaptec Ultra DMA/66 RAID"))
 or 
((id = "160045") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}Adaptec 2930U Kit"))
 or 
((id = "160059") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}Adaptec 19160 Kit"))
 or 
((id = "160078") and (state = "{state}On stock") and (description = "{pc.scsictrl.description}Adaptec 29160 Kit"))
 or 
((id = "160063") and (state = "{state}Not on stock") and (description = "{pc.scsictrl.description}Adaptec 39160 Kit"))
 or 
((id = "160084") and (state = "{state}Not on stock") and (description = "{pc.scsictrl.description}Adaptec 3200S"))
 or 
((id = "160085") and (state = "{state}Not on stock") and (description = "{pc.scsictrl.description}Adaptec 3400S"))
;
};
 Cddvd : {
private  id : ["1000006"
| "220163"
| "220164"
| "220095"
| "220106"
| "220009"
| "220168"
| "220162"
| "220146"
| "220166"
| "220152"
| "220154"
| "220156"
| "220171"
| "220142"
| "220176"
| "220144"
| "220145"
| "220174"
| "220175"
| "220172"
| "220161"
| "370429"
];
private state : State;
public  brandmodel : ["{pc.cddvd.brandmodel}- None -"
| "{pc.cddvd.brandmodel}Creative CD-DVD"
| "{pc.cddvd.brandmodel}Creative PC-DVD Encore"
| "{pc.cddvd.brandmodel}HP CD-Writer 9150i"
| "{pc.cddvd.brandmodel}HP CD-Writer 9510i"
| "{pc.cddvd.brandmodel}HP CD-Writer 9600si"
| "{pc.cddvd.brandmodel}LG"
| "{pc.cddvd.brandmodel}No name"
| "{pc.cddvd.brandmodel}Panasonic DVD-RAM LF-D201E"
| "{pc.cddvd.brandmodel}Pioneer DVD-105SZ"
| "{pc.cddvd.brandmodel}Pioneer DVD-115"
| "{pc.cddvd.brandmodel}Pioneer DVD-305S"
| "{pc.cddvd.brandmodel}Pioneer DVD-A05SZ"
| "{pc.cddvd.brandmodel}Pioneer DVD-U05S"
| "{pc.cddvd.brandmodel}Plextor PlexWriter SCSI"
| "{pc.cddvd.brandmodel}Plextor PlexWriter IDE"
| "{pc.cddvd.brandmodel}Sony CRX160E-RP"
| "{pc.cddvd.brandmodel}TEAC CD-532S"
| "{pc.cddvd.brandmodel}TEAC CD-540E"
| "{pc.cddvd.brandmodel}TEAC CDW512E"
| "{pc.cddvd.brandmodel}TEAC CDW512EA"
| "{pc.cddvd.brandmodel}Toshiba SD-R1002"
];
public  speed : ["{pc.cddvd.speed}-"
| "{pc.cddvd.speed}0x/32x/0x"
| "{pc.cddvd.speed}0x/40x/0x"
| "{pc.cddvd.speed}0x/40x/10x"
| "{pc.cddvd.speed}0x/40x/12x"
| "{pc.cddvd.speed}0x/40x/16x"
| "{pc.cddvd.speed}?x/20x/2x"
| "{pc.cddvd.speed}0x/52x/0x"
| "{pc.cddvd.speed}4x/24x/4x"
| "{pc.cddvd.speed}8x/32x/0x"
| "{pc.cddvd.speed}12x/32x/0x"
];
public  cdr : ["{pc.cddvd.cdr}0"
| "{pc.cddvd.cdr}1"
];
public  cdw : ["{pc.cddvd.cdw}0"
| "{pc.cddvd.cdw}1"
];
public  dvdr : ["{pc.cddvd.dvdr}0"
| "{pc.cddvd.dvdr}1"
];
public  dvdw : ["{pc.cddvd.dvdw}0"
| "{pc.cddvd.dvdw}1"
];
private hdtype : ["{pc.cddvd.hdtype}-"
| "{pc.cddvd.hdtype}ide"
| "{pc.cddvd.hdtype}scsi"
];
rule
((id = "1000006") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}- None -") and (speed = "{pc.cddvd.speed}-") and (cdr = "{pc.cddvd.cdr}0") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}-"))
 or 
((id = "220163") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}No name") and (speed = "{pc.cddvd.speed}0x/52x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220164") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}LG") and (speed = "{pc.cddvd.speed}0x/52x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220095") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}TEAC CD-540E") and (speed = "{pc.cddvd.speed}0x/40x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220009") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}TEAC CD-532S") and (speed = "{pc.cddvd.speed}0x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220168") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}TEAC CDW512EA") and (speed = "{pc.cddvd.speed}12x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220162") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}TEAC CDW512E") and (speed = "{pc.cddvd.speed}12x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220146") and (state = "{state}Not on stock") and (brandmodel = "{pc.cddvd.brandmodel}Plextor PlexWriter IDE") and (speed = "{pc.cddvd.speed}12x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220166") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}Plextor PlexWriter SCSI") and (speed = "{pc.cddvd.speed}12x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}scsi"))
 or 
((id = "220152") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}HP CD-Writer 9150i") and (speed = "{pc.cddvd.speed}8x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220154") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}HP CD-Writer 9510i") and (speed = "{pc.cddvd.speed}12x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220156") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}HP CD-Writer 9600si") and (speed = "{pc.cddvd.speed}12x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}scsi"))
 or 
((id = "220171") and (state = "{state}Not on stock") and (brandmodel = "{pc.cddvd.brandmodel}Sony CRX160E-RP") and (speed = "{pc.cddvd.speed}12x/32x/0x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}0") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220142") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}Toshiba SD-R1002") and (speed = "{pc.cddvd.speed}4x/24x/4x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220176") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}Pioneer DVD-115") and (speed = "{pc.cddvd.speed}0x/40x/16x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220144") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}Pioneer DVD-105SZ") and (speed = "{pc.cddvd.speed}0x/40x/16x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220145") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}Pioneer DVD-A05SZ") and (speed = "{pc.cddvd.speed}0x/40x/16x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220174") and (state = "{state}Not on stock") and (brandmodel = "{pc.cddvd.brandmodel}Pioneer DVD-305S") and (speed = "{pc.cddvd.speed}0x/40x/10x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}scsi"))
 or 
((id = "220175") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}Pioneer DVD-U05S") and (speed = "{pc.cddvd.speed}0x/40x/10x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}scsi"))
 or 
((id = "220172") and (state = "{state}Not on stock") and (brandmodel = "{pc.cddvd.brandmodel}Creative CD-DVD") and (speed = "{pc.cddvd.speed}0x/40x/12x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "220161") and (state = "{state}On stock") and (brandmodel = "{pc.cddvd.brandmodel}Creative PC-DVD Encore") and (speed = "{pc.cddvd.speed}0x/40x/12x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}0") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}0") and (hdtype = "{pc.cddvd.hdtype}ide"))
 or 
((id = "370429") and (state = "{state}Not on stock") and (brandmodel = "{pc.cddvd.brandmodel}Panasonic DVD-RAM LF-D201E") and (speed = "{pc.cddvd.speed}?x/20x/2x") and (cdr = "{pc.cddvd.cdr}1") and (cdw = "{pc.cddvd.cdw}1") and (dvdr = "{pc.cddvd.dvdr}1") and (dvdw = "{pc.cddvd.dvdw}1") and (hdtype = "{pc.cddvd.hdtype}scsi"))
;
};
 Netcard : {
private  id : ["1000007"
| "282833"
| "280004"
| "280233"
| "280105"
| "280133"
| "280132"
| "280161"
| "280228"
| "280404"
| "280046"
| "280042"
| "280098"
| "280227"
| "280176"
| "280193"
];
private state : State;
public  brandmodel : ["{pc.netcard.brandmodel}- None -"
| "{pc.netcard.brandmodel}3Com EtherLink"
| "{pc.netcard.brandmodel}3Com EtherLink III/16"
| "{pc.netcard.brandmodel}3Com EtherLink XL"
| "{pc.netcard.brandmodel}Edimax"
| "{pc.netcard.brandmodel}Intel Pro/100+"
| "{pc.netcard.brandmodel}Intel Pro/1000T"
];
public  speed : ["{pc.netcard.speed}0 Mbps"
| "{pc.netcard.speed}10 Mbps"
| "{pc.netcard.speed}10/100 Mbps"
| "{pc.netcard.speed}1000 Mbps"
];
private net : boolean;
rule
((id = "1000007") and (state = "{state}On stock") and (speed = "{pc.netcard.speed}0 Mbps") and (brandmodel = "{pc.netcard.brandmodel}- None -"))
 or 
((id = "280004") and (state = "{state}On stock") and (speed = "{pc.netcard.speed}10 Mbps") and (brandmodel = "{pc.netcard.brandmodel}Edimax"))
 or 
((id = "280105") and (state = "{state}On stock") and (speed = "{pc.netcard.speed}10/100 Mbps") and (brandmodel = "{pc.netcard.brandmodel}Edimax"))
 or 
((id = "280228") and (state = "{state}Not on stock") and (speed = "{pc.netcard.speed}10/100 Mbps") and (brandmodel = "{pc.netcard.brandmodel}Intel Pro/100+"))
 or 
((id = "280404") and (state = "{state}Not on stock") and (speed = "{pc.netcard.speed}1000 Mbps") and (brandmodel = "{pc.netcard.brandmodel}Intel Pro/1000T"))
 or 
((id = "280042") and (state = "{state}On stock") and (speed = "{pc.netcard.speed}10 Mbps") and (brandmodel = "{pc.netcard.brandmodel}3Com EtherLink III/16"))
 or 
((id = "280227") and (state = "{state}Not on stock") and (speed = "{pc.netcard.speed}10/100 Mbps") and (brandmodel = "{pc.netcard.brandmodel}3Com EtherLink XL"))
 or 
((id = "280193") and (state = "{state}On stock") and (speed = "{pc.netcard.speed}10/100 Mbps") and (brandmodel = "{pc.netcard.brandmodel}3Com EtherLink"))
;
(net <-> (id <> "1000007"));
};
 Soundcard : {
private  id : ["1000008"
| "370099"
| "370404"
| "370271"
| "373258"
| "370137"
| "370241"
| "370388"
| "370252"
| "370387"
| "370386"
];
private state : State;
public  brandmodel : ["{pc.soundcard.brandmodel}- None -"
| "{pc.soundcard.brandmodel}Creative SB 16 PCI"
| "{pc.soundcard.brandmodel}Creative SB Live Player 1024"
| "{pc.soundcard.brandmodel}Creative SB Live! Platinium 5.1"
| "{pc.soundcard.brandmodel}Creative SB Live! Player 5.1"
| "{pc.soundcard.brandmodel}Creative SB PCI 128"
| "{pc.soundcard.brandmodel}Creative SB PCI 512"
| "{pc.soundcard.brandmodel}No name"
| "{pc.soundcard.brandmodel}Terra Tech DMX XFire 1024"
| "{pc.soundcard.brandmodel}WinFast"
];
private sound : boolean;
rule
((id = "1000008") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}- None -"))
 or 
((id = "370404") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}No name"))
 or 
((id = "370271") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}WinFast"))
 or 
((id = "373258") and (state = "{state}Not on stock") and (brandmodel = "{pc.soundcard.brandmodel}Terra Tech DMX XFire 1024"))
 or 
((id = "370137") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}Creative SB PCI 128"))
 or 
((id = "370241") and (state = "{state}Not on stock") and (brandmodel = "{pc.soundcard.brandmodel}Creative SB 16 PCI"))
 or 
((id = "370388") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}Creative SB PCI 512"))
 or 
((id = "370252") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}Creative SB Live Player 1024"))
 or 
((id = "370387") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}Creative SB Live! Player 5.1"))
 or 
((id = "370386") and (state = "{state}On stock") and (brandmodel = "{pc.soundcard.brandmodel}Creative SB Live! Platinium 5.1"))
;
(sound <-> (id <> "1000008"));
};
 Loudspeakers : {
private  id : ["1000009"
| "370390"
| "370391"
| "370393"
| "370394"
| "370365"
| "370366"
| "370367"
| "370409"
| "370406"
| "370407"
| "370408"
| "370376"
| "370377"
| "370378"
| "370414"
];
private state : State;
public  brandmodel : ["{pc.loudspeakers.brandmodel}- None -"
| "{pc.loudspeakers.brandmodel}Creative DTT 2200"
| "{pc.loudspeakers.brandmodel}Creative DTT 3500 Digital"
| "{pc.loudspeakers.brandmodel}Creative FPS 1500"
| "{pc.loudspeakers.brandmodel}Creative SW 310"
| "{pc.loudspeakers.brandmodel}Klipsch ProMedia 2.1"
| "{pc.loudspeakers.brandmodel}Labtec Edge-418"
| "{pc.loudspeakers.brandmodel}Labtec LCS-1060"
| "{pc.loudspeakers.brandmodel}Labtec LCS-1070"
| "{pc.loudspeakers.brandmodel}Logitech SoundMan S-20"
| "{pc.loudspeakers.brandmodel}Logitech SoundMan S-30"
| "{pc.loudspeakers.brandmodel}Logitech SoundMan S-4"
| "{pc.loudspeakers.brandmodel}Trust Soundwave 1000"
| "{pc.loudspeakers.brandmodel}Trust Soundwave 1000 Flat panel"
| "{pc.loudspeakers.brandmodel}Trust Soundwave 160"
| "{pc.loudspeakers.brandmodel}Trust Soundwave 200"
];
private sound : boolean;
rule
((id = "1000009") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}- None -"))
 or 
((id = "370390") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Trust Soundwave 160"))
 or 
((id = "370391") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Trust Soundwave 200"))
 or 
((id = "370393") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Trust Soundwave 1000"))
 or 
((id = "370394") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Trust Soundwave 1000 Flat panel"))
 or 
((id = "370365") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Labtec LCS-1060"))
 or 
((id = "370366") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Labtec LCS-1070"))
 or 
((id = "370367") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Labtec Edge-418"))
 or 
((id = "370409") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Creative SW 310"))
 or 
((id = "370406") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Creative FPS 1500"))
 or 
((id = "370407") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Creative DTT 2200"))
 or 
((id = "370408") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Creative DTT 3500 Digital"))
 or 
((id = "370376") and (state = "{state}Not on stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Logitech SoundMan S-4"))
 or 
((id = "370377") and (state = "{state}Not on stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Logitech SoundMan S-20"))
 or 
((id = "370378") and (state = "{state}On stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Logitech SoundMan S-30"))
 or 
((id = "370414") and (state = "{state}Not on stock") and (brandmodel = "{pc.loudspeakers.brandmodel}Klipsch ProMedia 2.1"))
;
(sound <-> (id <> "1000009"));
};
 Mouse : {
private  id : ["1000010"
| "330146"
| "330053"
| "330109"
| "330029"
| "330020"
| "330035"
| "330112"
| "330134"
| "330116"
| "330027"
| "330135"
| "330115"
| "330145"
| "330102"
| "333334"
| "330072"
| "330073"
| "332795"
| "333240"
| "330003"
| "330137"
| "330024"
| "330018"
| "330062"
| "330123"
| "330064"
| "330106"
| "330063"
| "330122"
| "330006"
| "330014"
];
private state : State;
public  brand : ["{pc.mouse.brand}- None -"
| "{pc.mouse.brand}Cyper"
| "{pc.mouse.brand}Genius"
| "{pc.mouse.brand}Logitech"
| "{pc.mouse.brand}Microsoft"
];
public  model : ["{pc.mouse.model}- None -"
| "{pc.mouse.model}Basic Mouse"
| "{pc.mouse.model}Cordless MouseMan Wheel"
| "{pc.mouse.model}Cordless TrackMan FX"
| "{pc.mouse.model}Cordless Trackman Live"
| "{pc.mouse.model}Cordless Trackman Whell"
| "{pc.mouse.model}Cordless Wheel Mouse"
| "{pc.mouse.model}Defender"
| "{pc.mouse.model}Easy Mouse"
| "{pc.mouse.model}Force Feedback Mouse"
| "{pc.mouse.model}iFeel MouseMan Optical Mouse"
| "{pc.mouse.model}iFeel Optical Mouse"
| "{pc.mouse.model}IntelliMouse"
| "{pc.mouse.model}IntelliMouse Clear Limited"
| "{pc.mouse.model}IntelliMouse Explorer"
| "{pc.mouse.model}IntelliMouse Optical"
| "{pc.mouse.model}IntelliMouse Trackball"
| "{pc.mouse.model}IntelliMouse Trackball Optical"
| "{pc.mouse.model}IntelliMouse Web"
| "{pc.mouse.model}Marble Mouse"
| "{pc.mouse.model}Mini Wheel Mouse"
| "{pc.mouse.model}MouseMan Wheel Optical"
| "{pc.mouse.model}No name"
| "{pc.mouse.model}OEM Defender"
| "{pc.mouse.model}Optical Wheel Mouse"
| "{pc.mouse.model}Pilot Wheel Mouse Optical"
| "{pc.mouse.model}Trekker"
| "{pc.mouse.model}Trekker Wheel"
| "{pc.mouse.model}USB Pilot Wheel Mouse"
| "{pc.mouse.model}Wheel Mouse"
| "{pc.mouse.model}Wheel Mouse Optical"
];
rule
((id = "1000010") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}- None -") and (model = "{pc.mouse.model}- None -"))
 or 
((id = "330146") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Cyper") and (model = "{pc.mouse.model}No name"))
 or 
((id = "330053") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}USB Pilot Wheel Mouse"))
 or 
((id = "330109") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Mini Wheel Mouse"))
 or 
((id = "330029") and (state = "{state}Not on stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Pilot Wheel Mouse Optical"))
 or 
((id = "330020") and (state = "{state}Not on stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Cordless Wheel Mouse"))
 or 
((id = "330035") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Marble Mouse"))
 or 
((id = "330112") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Optical Wheel Mouse"))
 or 
((id = "330134") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}iFeel Optical Mouse"))
 or 
((id = "330116") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}MouseMan Wheel Optical"))
 or 
((id = "330027") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Cordless MouseMan Wheel"))
 or 
((id = "330135") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}iFeel MouseMan Optical Mouse"))
 or 
((id = "330115") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Cordless Trackman Whell"))
 or 
((id = "330145") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Cordless TrackMan FX"))
 or 
((id = "330102") and (state = "{state}Not on stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Force Feedback Mouse"))
 or 
((id = "333334") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Logitech") and (model = "{pc.mouse.model}Cordless Trackman Live"))
 or 
((id = "330072") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}Trekker"))
 or 
((id = "330073") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}Trekker Wheel"))
 or 
((id = "332795") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}OEM Defender"))
 or 
((id = "333240") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}Defender"))
 or 
((id = "330003") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}IntelliMouse"))
 or 
((id = "330137") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}IntelliMouse Web"))
 or 
((id = "330024") and (state = "{state}Not on stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}Basic Mouse"))
 or 
((id = "330018") and (state = "{state}Not on stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}Wheel Mouse"))
 or 
((id = "330062") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}Cordless Wheel Mouse"))
 or 
((id = "330123") and (state = "{state}Not on stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}Wheel Mouse Optical"))
 or 
((id = "330064") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}IntelliMouse Clear Limited"))
 or 
((id = "330106") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}IntelliMouse Optical"))
 or 
((id = "330063") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}IntelliMouse Explorer"))
 or 
((id = "330122") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}IntelliMouse Trackball Optical"))
 or 
((id = "330006") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Microsoft") and (model = "{pc.mouse.model}IntelliMouse Trackball"))
 or 
((id = "330014") and (state = "{state}On stock") and (brand = "{pc.mouse.brand}Genius") and (model = "{pc.mouse.model}Easy Mouse"))
;
};
 Keyboard : {
private  id : ["1000011"
| "260053"
| "260080"
| "260083"
| "260025"
| "260047"
| "260084"
| "260045"
| "260076"
| "260075"
| "260043"
| "262679"
| "260012"
| "260000"
| "260001"
| "260057"
| "260068"
| "260058"
];
private state : State;
public  brand : ["{pc.keyboard.brand}- None -"
| "{pc.keyboard.brand}Cherry"
| "{pc.keyboard.brand}Cyper"
| "{pc.keyboard.brand}Keytronic"
| "{pc.keyboard.brand}Logitech"
| "{pc.keyboard.brand}Microsoft"
];
public  model : ["{pc.keyboard.model}- None -"
| "{pc.keyboard.model}Cordless Desktop iTouch II"
| "{pc.keyboard.model}Cordless Desktop Light"
| "{pc.keyboard.model}Cordless Desktop Pro"
| "{pc.keyboard.model}Deluxe Access"
| "{pc.keyboard.model}G81-1800"
| "{pc.keyboard.model}G81-3000"
| "{pc.keyboard.model}G84-4100"
| "{pc.keyboard.model}Internet"
| "{pc.keyboard.model}Internet Keyboard"
| "{pc.keyboard.model}Internet Keyboard Pro"
| "{pc.keyboard.model}iTouch"
| "{pc.keyboard.model}KT2001"
| "{pc.keyboard.model}MPR II"
| "{pc.keyboard.model}Multimedie"
| "{pc.keyboard.model}Natural Keyboard Pro"
];
public  language : ["{pc.keyboard.language}- None -"
| "{pc.keyboard.language}US"
| "{pc.keyboard.language}DK"
];
rule
((id = "1000011") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}- None -") and (model = "{pc.keyboard.model}- None -") and (language = "{pc.keyboard.language}- None -"))
 or 
((id = "260053") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Cyper") and (model = "{pc.keyboard.model}MPR II") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260080") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Cyper") and (model = "{pc.keyboard.model}Internet") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260083") and (state = "{state}Not on stock") and (brand = "{pc.keyboard.brand}Cyper") and (model = "{pc.keyboard.model}Multimedie") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260025") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Keytronic") and (model = "{pc.keyboard.model}KT2001") and (language = "{pc.keyboard.language}DK"))
 or 
((id = "260047") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Logitech") and (model = "{pc.keyboard.model}Internet") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260084") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Logitech") and (model = "{pc.keyboard.model}Deluxe Access") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260045") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Logitech") and (model = "{pc.keyboard.model}iTouch") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260076") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Logitech") and (model = "{pc.keyboard.model}Cordless Desktop Light") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260075") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Logitech") and (model = "{pc.keyboard.model}Cordless Desktop iTouch II") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260043") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Logitech") and (model = "{pc.keyboard.model}Cordless Desktop Pro") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260012") and (state = "{state}Not on stock") and (brand = "{pc.keyboard.brand}Cherry") and (model = "{pc.keyboard.model}G81-1800") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260000") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Cherry") and (model = "{pc.keyboard.model}G84-4100") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260001") and (state = "{state}Not on stock") and (brand = "{pc.keyboard.brand}Cherry") and (model = "{pc.keyboard.model}G81-3000") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260057") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Microsoft") and (model = "{pc.keyboard.model}Internet Keyboard") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260068") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Microsoft") and (model = "{pc.keyboard.model}Internet Keyboard Pro") and (language = "{pc.keyboard.language}US"))
 or 
((id = "260058") and (state = "{state}On stock") and (brand = "{pc.keyboard.brand}Microsoft") and (model = "{pc.keyboard.model}Natural Keyboard Pro") and (language = "{pc.keyboard.language}US"))
;
};
 Cabinet : {
private  id : ["400061"
| "404024"
| "404111"
| "404112"
];
private state : State;
public  description : ["{pc.cabinet.description}Slimline Desktop"
| "{pc.cabinet.description}Micro Tower"
| "{pc.cabinet.description}Midi Tower"
| "{pc.cabinet.description}Maxi Tower"
];
private formfactor : Formfactor;
rule
((id = "400061") and (state = "{state}Not on stock") and (description = "{pc.cabinet.description}Slimline Desktop") and (formfactor = uATX))
 or 
((id = "404024") and (state = "{state}On stock") and (description = "{pc.cabinet.description}Micro Tower") and (formfactor = uATX))
 or 
((id = "404111") and (state = "{state}On stock") and (description = "{pc.cabinet.description}Midi Tower") and (formfactor = ATX))
 or 
((id = "404112") and (state = "{state}On stock") and (description = "{pc.cabinet.description}Maxi Tower") and (formfactor = ATX))
;
};
 Printer : {
private  id : ["1000014"
| "340144"
| "340134"
| "340408"
];
private state : State;
public  brand : ["{pc.printer.brand}- None -"
| "{pc.printer.brand}Canon"
| "{pc.printer.brand}HP"
];
public  model : ["{pc.printer.model}- None -"
| "{pc.printer.model}BJC-50"
| "{pc.printer.model}DeskJet 350C"
| "{pc.printer.model}LaserJet 1100"
];
public  tech : ["{pc.printer.tech}laser"
| "{pc.printer.tech}ink"
];
public  colour : ["{pc.printer.colour}s/h"
| "{pc.printer.colour}color"
];
rule
((id = "1000014") and (state = "{state}On stock") and (tech = "{pc.printer.tech}laser") and (colour = "{pc.printer.colour}s/h") and (brand = "{pc.printer.brand}- None -") and (model = "{pc.printer.model}- None -"))
 or 
((id = "340144") and (state = "{state}Not on stock") and (tech = "{pc.printer.tech}ink") and (colour = "{pc.printer.colour}color") and (brand = "{pc.printer.brand}Canon") and (model = "{pc.printer.model}BJC-50"))
 or 
((id = "340134") and (state = "{state}On stock") and (tech = "{pc.printer.tech}laser") and (colour = "{pc.printer.colour}s/h") and (brand = "{pc.printer.brand}HP") and (model = "{pc.printer.model}LaserJet 1100"))
 or 
((id = "340408") and (state = "{state}Not on stock") and (tech = "{pc.printer.tech}ink") and (colour = "{pc.printer.colour}color") and (brand = "{pc.printer.brand}HP") and (model = "{pc.printer.model}DeskJet 350C"))
;
};
 Gc : {
private  id : ["1000015"
| "360318"
| "360317"
| "360314"
| "360156"
| "360107"
| "360275"
| "360288"
| "360322"
| "360232"
| "360269"
| "360304"
| "360272"
| "360276"
| "360277"
| "360294"
| "360290"
| "360299"
| "360310"
| "360305"
| "360306"
| "360192"
];
private state : State;
public  brand : ["{pc.gc.brand}- None -"
| "{pc.gc.brand}3Dfx"
| "{pc.gc.brand}Asus"
| "{pc.gc.brand}ATI"
| "{pc.gc.brand}Creative"
| "{pc.gc.brand}Matrox"
| "{pc.gc.brand}No name"
| "{pc.gc.brand}WinFast"
];
public  model : ["{pc.gc.model}- None -"
| "{pc.gc.model}3D S320V"
| "{pc.gc.model}3D S325"
| "{pc.gc.model}GeForce2 256 DDR"
| "{pc.gc.model}GeForce2 GTS"
| "{pc.gc.model}GeForce2 MX"
| "{pc.gc.model}GeForce2 MX DH Pro"
| "{pc.gc.model}Millenium G200"
| "{pc.gc.model}Millenium G450"
| "{pc.gc.model}Millenium G450LE"
| "{pc.gc.model}No name"
| "{pc.gc.model}Radeon"
| "{pc.gc.model}Radeon All-In-Wonder"
| "{pc.gc.model}V7100"
| "{pc.gc.model}V7700"
| "{pc.gc.model}V7700 Deluxe"
| "{pc.gc.model}Voodoo4 4500"
| "{pc.gc.model}Xpert 98"
];
public  ramsize : ["{pc.gc.ramsize}0 Mb"
| "{pc.gc.ramsize}4 Mb"
| "{pc.gc.ramsize}8 Mb"
| "{pc.gc.ramsize}16 Mb"
| "{pc.gc.ramsize}32 Mb"
| "{pc.gc.ramsize}64 Mb"
];
rule
((id = "1000015") and (state = "{state}On stock") and (brand = "{pc.gc.brand}- None -") and (model = "{pc.gc.model}- None -") and (ramsize = "{pc.gc.ramsize}0 Mb"))
 or 
((id = "360317") and (state = "{state}On stock") and (brand = "{pc.gc.brand}Creative") and (model = "{pc.gc.model}GeForce2 MX") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360314") and (state = "{state}Not on stock") and (brand = "{pc.gc.brand}3Dfx") and (model = "{pc.gc.model}Voodoo4 4500") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360156") and (state = "{state}On stock") and (brand = "{pc.gc.brand}Matrox") and (model = "{pc.gc.model}Millenium G200") and (ramsize = "{pc.gc.ramsize}8 Mb"))
 or 
((id = "360107") and (state = "{state}On stock") and (brand = "{pc.gc.brand}No name") and (model = "{pc.gc.model}No name") and (ramsize = "{pc.gc.ramsize}4 Mb"))
 or 
((id = "360275") and (state = "{state}On stock") and (brand = "{pc.gc.brand}WinFast") and (model = "{pc.gc.model}3D S325") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360288") and (state = "{state}On stock") and (brand = "{pc.gc.brand}WinFast") and (model = "{pc.gc.model}GeForce2 MX") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360322") and (state = "{state}On stock") and (brand = "{pc.gc.brand}WinFast") and (model = "{pc.gc.model}GeForce2 MX DH Pro") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360232") and (state = "{state}On stock") and (brand = "{pc.gc.brand}WinFast") and (model = "{pc.gc.model}GeForce2 256 DDR") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360269") and (state = "{state}On stock") and (brand = "{pc.gc.brand}WinFast") and (model = "{pc.gc.model}GeForce2 GTS") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360304") and (state = "{state}On stock") and (brand = "{pc.gc.brand}ATI") and (model = "{pc.gc.model}Xpert 98") and (ramsize = "{pc.gc.ramsize}8 Mb"))
 or 
((id = "360272") and (state = "{state}On stock") and (brand = "{pc.gc.brand}ATI") and (model = "{pc.gc.model}Radeon") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360276") and (state = "{state}On stock") and (brand = "{pc.gc.brand}ATI") and (model = "{pc.gc.model}Radeon") and (ramsize = "{pc.gc.ramsize}64 Mb"))
 or 
((id = "360277") and (state = "{state}Not on stock") and (brand = "{pc.gc.brand}ATI") and (model = "{pc.gc.model}Radeon All-In-Wonder") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360294") and (state = "{state}Not on stock") and (brand = "{pc.gc.brand}Asus") and (model = "{pc.gc.model}V7100") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360290") and (state = "{state}On stock") and (brand = "{pc.gc.brand}Asus") and (model = "{pc.gc.model}V7700") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360299") and (state = "{state}Not on stock") and (brand = "{pc.gc.brand}Asus") and (model = "{pc.gc.model}V7700 Deluxe") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360310") and (state = "{state}On stock") and (brand = "{pc.gc.brand}Matrox") and (model = "{pc.gc.model}Millenium G450LE") and (ramsize = "{pc.gc.ramsize}16 Mb"))
 or 
((id = "360305") and (state = "{state}On stock") and (brand = "{pc.gc.brand}Matrox") and (model = "{pc.gc.model}Millenium G450") and (ramsize = "{pc.gc.ramsize}16 Mb"))
 or 
((id = "360306") and (state = "{state}On stock") and (brand = "{pc.gc.brand}Matrox") and (model = "{pc.gc.model}Millenium G450") and (ramsize = "{pc.gc.ramsize}32 Mb"))
 or 
((id = "360192") and (state = "{state}On stock") and (brand = "{pc.gc.brand}WinFast") and (model = "{pc.gc.model}3D S320V") and (ramsize = "{pc.gc.ramsize}8 Mb"))
;
};
 Monitor : {
private  id : ["1000016"
| "121260"
| "121333"
| "120151"
| "120126"
| "121291"
| "121292"
| "121340"
| "121341"
| "121403"
| "121405"
| "121327"
| "121401"
| "121402"
| "121329"
| "120202"
| "120208"
| "120203"
| "120206"
| "120117"
| "120118"
| "120205"
| "120207"
| "120303"
| "120308"
| "120304"
| "120410"
| "120119"
| "120403"
| "120401"
| "120407"
| "120405"
| "120408"
| "120409"
| "120411"
| "120406"
| "120113"
| "120129"
| "120138"
| "120144"
| "120604"
| "121343"
| "121346"
| "120603"
| "121344"
| "121356"
| "120149"
| "120136"
| "120503"
| "120510"
| "120509"
| "120506"
| "120501"
];
private state : State;
public  brand : ["{pc.monitor.brand}- None -"
| "{pc.monitor.brand}Cyper"
| "{pc.monitor.brand}EIZO"
| "{pc.monitor.brand}Hitachi"
| "{pc.monitor.brand}LG"
| "{pc.monitor.brand}Mermaid"
| "{pc.monitor.brand}Nokia"
| "{pc.monitor.brand}Samsung"
| "{pc.monitor.brand}Sony"
];
public  model : ["{pc.monitor.model}- None -"
| "{pc.monitor.model}150AT (bl)"
| "{pc.monitor.model}150AT (sort)"
| "{pc.monitor.model}170AT"
| "{pc.monitor.model}445pro"
| "{pc.monitor.model}510L"
| "{pc.monitor.model}530L"
| "{pc.monitor.model}710C"
| "{pc.monitor.model}800pro/+"
| "{pc.monitor.model}820L"
| "{pc.monitor.model}920C"
| "{pc.monitor.model}CM615ET"
| "{pc.monitor.model}CM625ET"
| "{pc.monitor.model}CM715ET"
| "{pc.monitor.model}CM772ET"
| "{pc.monitor.model}CM813ETM+"
| "{pc.monitor.model}CM815ETM+"
| "{pc.monitor.model}CML151XW"
| "{pc.monitor.model}CML170SXW"
| "{pc.monitor.model}Flatron 774FT"
| "{pc.monitor.model}Flatron 775FT"
| "{pc.monitor.model}Flatron 776FT"
| "{pc.monitor.model}Flatron 795FT"
| "{pc.monitor.model}Flatron 915FT"
| "{pc.monitor.model}FlexScan F520"
| "{pc.monitor.model}FlexScan F730"
| "{pc.monitor.model}FlexScan F930"
| "{pc.monitor.model}L181"
| "{pc.monitor.model}Multiscan E220E"
| "{pc.monitor.model}Multiscan E400"
| "{pc.monitor.model}Multiscan E500"
| "{pc.monitor.model}Multiscan F500"
| "{pc.monitor.model}Multiscan FW900"
| "{pc.monitor.model}Multiscan G200"
| "{pc.monitor.model}Multiscan G400"
| "{pc.monitor.model}Multiscan G500"
| "{pc.monitor.model}Pro"
| "{pc.monitor.model}SDM-M51"
| "{pc.monitor.model}SDM-N50"
| "{pc.monitor.model}Studioworks 221U"
| "{pc.monitor.model}Studioworks 995E"
| "{pc.monitor.model}SW 880LC"
| "{pc.monitor.model}SyncMaster 570B"
| "{pc.monitor.model}SyncMaster 570S"
| "{pc.monitor.model}SyncMaster 770"
| "{pc.monitor.model}SyncMaster 800"
| "{pc.monitor.model}SyncMaster 900SL+"
| "{pc.monitor.model}SyncMaster 950p"
| "{pc.monitor.model}Touch screen"
| "{pc.monitor.model}With speakers"
];
public  size : [ "{pc.monitor.size}- None -"
| "{pc.monitor.size}15.0\""
| "{pc.monitor.size}15.1\""
| "{pc.monitor.size}17.0\""
| "{pc.monitor.size}18.1\""
| "{pc.monitor.size}19.0\""
| "{pc.monitor.size}21.0\""
| "{pc.monitor.size}24.0\""
];
public  tech : ["{pc.monitor.tech}CRT"
| "{pc.monitor.tech}TFT"
];
private sound : boolean;
private soundonboard : ["{pc.monitor.soundonboard}0"
| "{pc.monitor.soundonboard}1"
| "{pc.monitor.soundonboard}"
];
rule
((id = "1000016") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}- None -") and (size = "{pc.monitor.size}- None -") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}- None -") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121260") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Cyper") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Pro") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121333") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Cyper") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}With speakers") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "120151") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Cyper") and (size = "{pc.monitor.size}15.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}Pro") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120126") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Cyper") and (size = "{pc.monitor.size}15.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}With speakers") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121291") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Cyper") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Touch screen") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121292") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Cyper") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Touch screen") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121340") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Studioworks 995E") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121341") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Studioworks 221U") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121403") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Flatron 774FT") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121405") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Flatron 776FT") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "121327") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Flatron 795FT") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121401") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Flatron 915FT") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121402") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Flatron 775FT") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121329") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}LG") and (size = "{pc.monitor.size}18.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}SW 880LC") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120202") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}CM615ET") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120208") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}CM625ET") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120203") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}CM715ET") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120206") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}CM772ET") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120117") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}CM813ETM+") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120118") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}CM815ETM+") and (soundonboard = "{pc.monitor.soundonboard}"))
 or 
((id = "120205") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}CML151XW") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120207") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Hitachi") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}CML170SXW") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120303") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}EIZO") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}FlexScan F520") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120308") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}EIZO") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}FlexScan F730") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120304") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}EIZO") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}FlexScan F930") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120410") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan E220E") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120119") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan G200") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120403") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan E400") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120401") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan G400") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120407") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan E500") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120405") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan G500") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120408") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan F500") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120409") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}24.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}Multiscan FW900") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120411") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}15.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}SDM-M51") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120406") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}SDM-N50") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120113") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Sony") and (size = "{pc.monitor.size}18.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}L181") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120129") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Mermaid") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}150AT (bl)") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "120138") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Mermaid") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}150AT (sort)") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "120144") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Mermaid") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}170AT") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "120604") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Samsung") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}SyncMaster 950p") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121343") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Samsung") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}SyncMaster 900SL+") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121346") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Samsung") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}SyncMaster 570S") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120603") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Samsung") and (size = "{pc.monitor.size}15.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}SyncMaster 570B") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "121344") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Samsung") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}SyncMaster 770") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "121356") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Samsung") and (size = "{pc.monitor.size}18.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}SyncMaster 800") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120149") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Nokia") and (size = "{pc.monitor.size}17.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}710C") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120136") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Nokia") and (size = "{pc.monitor.size}19.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}920C") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120503") and (state = "{state}On stock") and (brand = "{pc.monitor.brand}Nokia") and (size = "{pc.monitor.size}21.0\"") and (tech = "{pc.monitor.tech}CRT") and (model = "{pc.monitor.model}445pro") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120510") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Nokia") and (size = "{pc.monitor.size}15.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}510L") and (soundonboard = "{pc.monitor.soundonboard}0"))
 or 
((id = "120509") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Nokia") and (size = "{pc.monitor.size}15.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}530L") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "120506") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Nokia") and (size = "{pc.monitor.size}18.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}820L") and (soundonboard = "{pc.monitor.soundonboard}1"))
 or 
((id = "120501") and (state = "{state}Not on stock") and (brand = "{pc.monitor.brand}Nokia") and (size = "{pc.monitor.size}18.1\"") and (tech = "{pc.monitor.tech}TFT") and (model = "{pc.monitor.model}800pro/+") and (soundonboard = "{pc.monitor.soundonboard}1"))
;
(sound <-> (soundonboard = "{pc.monitor.soundonboard}1"));
};
 Os : {
private  id : ["1000017"
| "010230"
| "010231"
];
private state : State;
public  description : ["{pc.os.description}- None -"
| "{pc.os.description}Win. ME, Corel Office"
| "{pc.os.description}Win. 2000, MS Office"
];
public  installation : boolean;
rule
((id = "1000017") and (state = "{state}On stock") and (description = "{pc.os.description}- None -"))
 or 
((id = "010230") and (state = "{state}On stock") and (description = "{pc.os.description}Win. ME, Corel Office"))
 or 
((id = "010231") and (state = "{state}On stock") and (description = "{pc.os.description}Win. 2000, MS Office"))
;
(installation -> (id <> "1000017"));
};
 Modem : {
private  id : ["1000019"
| "230052"
| "230074"
| "230088"
| "230020"
| "230084"
| "230446"
| "230447"
| "230126"
];
private state : State;
public  brandmodel : ["{pc.modem.brandmodel}- None -"
| "{pc.modem.brandmodel}Eksternt 56K"
| "{pc.modem.brandmodel}Faxmodem 56K"
| "{pc.modem.brandmodel}Internt 56K"
| "{pc.modem.brandmodel}Lasat Safire"
| "{pc.modem.brandmodel}Lasat Safire II"
| "{pc.modem.brandmodel}Lasat Websetgo"
];
rule
((id = "1000019") and (state = "{state}On stock") and (brandmodel = "{pc.modem.brandmodel}- None -"))
 or 
((id = "230052") and (state = "{state}On stock") and (brandmodel = "{pc.modem.brandmodel}Internt 56K"))
 or 
((id = "230088") and (state = "{state}Not on stock") and (brandmodel = "{pc.modem.brandmodel}Eksternt 56K"))
 or 
((id = "230020") and (state = "{state}On stock") and (brandmodel = "{pc.modem.brandmodel}Lasat Safire"))
 or 
((id = "230084") and (state = "{state}Not on stock") and (brandmodel = "{pc.modem.brandmodel}Lasat Safire II"))
 or 
((id = "230447") and (state = "{state}On stock") and (brandmodel = "{pc.modem.brandmodel}Faxmodem 56K"))
 or 
((id = "230126") and (state = "{state}Not on stock") and (brandmodel = "{pc.modem.brandmodel}Lasat Websetgo"))
;
};
 Features : {
public  model : ["{model}Fully chosen"
| "{model}Partly configurable"
| "{model}Fully configurable"
];
private sound : boolean;
private net : boolean;
private hdsize : Undef;
public  state : State;
private capability : {
public  multimedia : Capability;
public  games : Capability;
public  server : Capability;
public  office : Capability;
};
};
 Pc : {
public  features : Features;
public  cabinet : Cabinet;
public  mb : Mb;
public  scsictrl : Scsictrl;
public  hd0 : Hd;
public  hd1 : Hd;
public  cpu : Cpu;
private  ram : array ram_max of Ram;
public  ramcapacity : Ramcapacity;
public  cddvd : Cddvd;
public  netcard : Netcard;
public  soundcard : Soundcard;
public  loudspeakers : Loudspeakers;
public  mouse : Mouse;
public  keyboard : Keyboard;
public  printer : Printer;
public  gc : Gc;
public  monitor : Monitor;
public  os : Os;
public  modem : Modem;
rule
((features.model = "{model}Fully chosen") and (mb.id = "350119"))
 or 
((features.model = "{model}Partly configurable") and (mb.id = "350119"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350283"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350119"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350159"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350251"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350219"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350216"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350266"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350245"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350243"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350208"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350223"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350185"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350227"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350226"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350268"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350239"))
 or 
((features.model = "{model}Fully configurable") and (mb.id = "350229"))
;
((features.model = "{model}Fully chosen") and (cpu.id = "150107"))
 or 
((features.model = "{model}Partly configurable") and (cpu.id = "150107"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150107"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150338"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150339"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150340"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150363"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150364"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150365"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150366"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150367"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150801"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150803"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150501"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150503"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150248"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150236"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150247"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150253"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150601"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150602"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150042"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150106"))
 or 
((features.model = "{model}Fully configurable") and (cpu.id = "150270"))
;
((features.model = "{model}Fully chosen") and (ram[0].id = "240020"))
 or 
((features.model = "{model}Partly configurable") and (ram[0].id = "240020"))
 or 
((features.model = "{model}Partly configurable") and (ram[0].id = "240021"))
 or 
((features.model = "{model}Partly configurable") and (ram[0].id = "240123"))
 or 
((features.model = "{model}Partly configurable") and (ram[0].id = "240138"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "1000003"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240020"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240021"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240123"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240138"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240081"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240122"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240160"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240196"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240023"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "249903"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240019"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240018"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240182"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240174"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240190"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240191"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240192"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240130"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240187"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "243003"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "243001"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "243002"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "242497"))
 or 
((features.model = "{model}Fully configurable") and (ram[0].id = "240005"))
;
((features.model <> "{model}Fully configurable") -> (((ram[1].id = "1000003") and (ram[2].id = "1000003")) and (ram[3].id = "1000003")));
((features.model = "{model}Fully chosen") and (hd0.id = "210424"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210424"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210425"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210426"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210427"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210429"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210430"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210431"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210432"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210433"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "211004"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "211005"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "211006"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210287"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210286"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210298"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210295"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210611"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210614"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210905"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210904"))
 or 
((features.model = "{model}Partly configurable") and (hd0.id = "210906"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "1000004"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210424"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210425"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210426"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210427"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210429"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210430"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210431"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210432"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210433"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210501"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210502"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210503"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210505"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210507"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210509"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210511"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210506"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210512"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "211004"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "211005"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "211006"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210287"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210286"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210298"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210295"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210296"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210297"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210611"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210614"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210706"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210708"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210710"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210707"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210709"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210711"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210905"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210904"))
 or 
((features.model = "{model}Fully configurable") and (hd0.id = "210906"))
;
((features.model <> "{model}Fully configurable") -> (hd1.id = "1000004"));
((features.model = "{model}Fully chosen") and (scsictrl.id = "1000005"))
 or 
((features.model = "{model}Partly configurable") and (scsictrl.id = "1000005"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "1000005"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160065"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160080"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160034"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160047"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160033"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160064"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160058"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "230087"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "230086"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160082"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "351004"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160045"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160059"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160078"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160063"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160084"))
 or 
((features.model = "{model}Fully configurable") and (scsictrl.id = "160085"))
;
((features.model = "{model}Fully chosen") and (cddvd.id = "220164"))
 or 
((features.model = "{model}Partly configurable") and (cddvd.id = "1000006"))
 or 
((features.model = "{model}Partly configurable") and (cddvd.id = "220163"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "1000006"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220163"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220164"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220095"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220106"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220009"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220168"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220162"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220146"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220166"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220152"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220154"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220156"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220171"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220142"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220176"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220144"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220145"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220174"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220175"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220172"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "220161"))
 or 
((features.model = "{model}Fully configurable") and (cddvd.id = "370429"))
;
((features.model = "{model}Fully chosen") and (netcard.id = "1000007"))
 or 
((features.model = "{model}Partly configurable") and (netcard.id = "1000007"))
 or 
((features.model = "{model}Partly configurable") and (netcard.id = "280004"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "1000007"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "282833"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280004"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280233"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280105"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280133"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280132"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280161"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280228"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280404"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280046"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280042"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280098"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280227"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280176"))
 or 
((features.model = "{model}Fully configurable") and (netcard.id = "280193"))
;
((features.model = "{model}Fully chosen") and (soundcard.id = "1000008"))
 or 
((features.model = "{model}Partly configurable") and (soundcard.id = "1000008"))
 or 
((features.model = "{model}Partly configurable") and (soundcard.id = "370137"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "1000008"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370099"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370404"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370271"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "373258"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370137"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370241"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370388"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370252"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370387"))
 or 
((features.model = "{model}Fully configurable") and (soundcard.id = "370386"))
;
((features.model = "{model}Fully chosen") and (loudspeakers.id = "1000009"))
 or 
((features.model = "{model}Partly configurable") and (loudspeakers.id = "1000009"))
 or 
((features.model = "{model}Partly configurable") and (loudspeakers.id = "370390"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "1000009"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370390"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370391"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370393"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370394"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370365"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370366"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370367"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370409"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370406"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370407"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370408"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370376"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370377"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370378"))
 or 
((features.model = "{model}Fully configurable") and (loudspeakers.id = "370414"))
;
((features.model = "{model}Fully chosen") and (mouse.id = "330020"))
 or 
((features.model = "{model}Partly configurable") and (mouse.id = "1000010"))
 or 
((features.model = "{model}Partly configurable") and (mouse.id = "330020"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "1000010"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330146"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330053"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330109"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330029"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330020"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330035"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330112"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330134"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330116"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330027"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330135"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330115"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330145"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330102"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "333334"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330072"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330073"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "332795"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "333240"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330003"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330137"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330024"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330018"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330062"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330123"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330064"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330106"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330063"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330122"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330006"))
 or 
((features.model = "{model}Fully configurable") and (mouse.id = "330014"))
;
((features.model = "{model}Fully chosen") and (keyboard.id = "260053"))
 or 
((features.model = "{model}Partly configurable") and (keyboard.id = "1000011"))
 or 
((features.model = "{model}Partly configurable") and (keyboard.id = "260053"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "1000011"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260053"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260080"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260083"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260025"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260047"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260084"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260045"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260076"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260075"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260075"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260075"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260075"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260043"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260043"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260043"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260043"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "262679"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260012"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260000"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260001"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260057"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260068"))
 or 
((features.model = "{model}Fully configurable") and (keyboard.id = "260058"))
;
((features.model = "{model}Fully chosen") and (cabinet.id = "404111"))
 or 
((features.model = "{model}Partly configurable") and (cabinet.id = "404111"))
 or 
((features.model = "{model}Fully configurable") and (cabinet.id = "400061"))
 or 
((features.model = "{model}Fully configurable") and (cabinet.id = "404024"))
 or 
((features.model = "{model}Fully configurable") and (cabinet.id = "404111"))
 or 
((features.model = "{model}Fully configurable") and (cabinet.id = "404112"))
;
((features.model = "{model}Fully chosen") and (printer.id = "1000014"))
 or 
((features.model = "{model}Partly configurable") and (printer.id = "1000014"))
 or 
((features.model = "{model}Partly configurable") and (printer.id = "340408"))
 or 
((features.model = "{model}Fully configurable") and (printer.id = "1000014"))
 or 
((features.model = "{model}Fully configurable") and (printer.id = "340144"))
 or 
((features.model = "{model}Fully configurable") and (printer.id = "340134"))
 or 
((features.model = "{model}Fully configurable") and (printer.id = "340408"))
;
((features.model = "{model}Fully chosen") and (gc.id = "360107"))
 or 
((features.model = "{model}Partly configurable") and (gc.id = "360317"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "1000015"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360318"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360317"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360314"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360156"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360107"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360275"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360288"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360322"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360232"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360269"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360304"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360272"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360276"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360277"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360294"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360290"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360299"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360310"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360305"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360306"))
 or 
((features.model = "{model}Fully configurable") and (gc.id = "360192"))
;
((features.model = "{model}Fully chosen") and (monitor.id = "121260"))
 or 
((features.model = "{model}Partly configurable") and (monitor.id = "1000016"))
 or 
((features.model = "{model}Partly configurable") and (monitor.id = "121333"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "1000016"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121260"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121333"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120151"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120126"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121291"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121292"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121340"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121341"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121403"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121405"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121327"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121401"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121402"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121329"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120202"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120208"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120203"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120206"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120117"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120118"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120205"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120207"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120303"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120308"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120304"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120410"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120119"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120403"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120401"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120407"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120405"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120408"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120409"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120411"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120406"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120113"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120129"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120138"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120144"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120604"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121343"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121346"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120603"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121344"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "121356"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120149"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120136"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120503"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120510"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120509"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120506"))
 or 
((features.model = "{model}Fully configurable") and (monitor.id = "120501"))
;
((features.model = "{model}Fully chosen") and (os.id = "1000017"))
 or 
((features.model = "{model}Partly configurable") and (os.id = "1000017"))
 or 
((features.model = "{model}Partly configurable") and (os.id = "010230"))
 or 
((features.model = "{model}Fully configurable") and (os.id = "1000017"))
 or 
((features.model = "{model}Fully configurable") and (os.id = "010230"))
 or 
((features.model = "{model}Fully configurable") and (os.id = "010231"))
;
((features.model = "{model}Fully chosen") and (modem.id = "1000019"))
 or 
((features.model = "{model}Partly configurable") and (modem.id = "1000019"))
 or 
((features.model = "{model}Partly configurable") and (modem.id = "230074"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "1000019"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230052"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230074"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230088"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230020"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230084"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230446"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230447"))
 or 
((features.model = "{model}Fully configurable") and (modem.id = "230126"))
;
(features.sound <-> ((mb.sound or soundcard.sound) and (loudspeakers.sound or monitor.sound)));
(features.net <-> (mb.net or netcard.net));
((features.state = "{state}On stock") <-> ((((((((((((((((((((mb.state = "{state}On stock") and (cpu.state = "{state}On stock")) and (ram[0].state = "{state}On stock")) and (ram[1].state = "{state}On stock")) and (ram[2].state = "{state}On stock")) and (ram[3].state = "{state}On stock")) and (hd0.state = "{state}On stock")) and (hd1.state = "{state}On stock")) and (scsictrl.state = "{state}On stock")) and (cddvd.state = "{state}On stock")) and (netcard.state = "{state}On stock")) and (soundcard.state = "{state}On stock")) and (loudspeakers.state = "{state}On stock")) and (mouse.state = "{state}On stock")) and (keyboard.state = "{state}On stock")) and (cabinet.state = "{state}On stock")) and (printer.state = "{state}On stock")) and (gc.state = "{state}On stock")) and (monitor.state = "{state}On stock")) and (os.state = "{state}On stock")));
((order(ramcapacity)) = ((((order(ram[0].capacity)) + (order(ram[1].capacity))) + (order(ram[2].capacity))) + (order(ram[3].capacity))));
if (features.model = "{model}Fully configurable") then (((hd0.capacity <> "N/A") and (ramcapacity <> "0 Mb")) and ((gc.id <> "1000015") or (mb.gconboard = "{pc.mb.gconboard}1"))) else true;
if (features.model = "{model}Fully configurable") then ((((((((((order(mb.ramnums)) <= (order("{ramnums}0"))) -> (ram[0].capacity = "0 Mb")) and (((order(mb.ramnums)) <= (order("{ramnums}1"))) -> (ram[1].capacity = "0 Mb"))) and (((order(mb.ramnums)) <= (order("{ramnums}2"))) -> (ram[2].capacity = "0 Mb"))) and (((order(mb.ramnums)) <= (order("{ramnums}3"))) -> (ram[3].capacity = "0 Mb"))) and ((ram[0].capacity <> "0 Mb") -> (mb.ramtype = ram[0].ramtype))) and ((ram[1].capacity <> "0 Mb") -> (mb.ramtype = ram[1].ramtype))) and ((ram[2].capacity <> "0 Mb") -> (mb.ramtype = ram[2].ramtype))) and ((ram[3].capacity <> "0 Mb") -> (mb.ramtype = ram[3].ramtype))) else true;
if (features.model = "{model}Fully configurable") then (((mb.cputype = cpu.cputype) and ((order(mb.speed_min)) <= (order(cpu.speed)))) and ((order(mb.speed_max)) >= (order(cpu.speed)))) else true;
if (features.model = "{model}Fully configurable") then (mb.formfactor = cabinet.formfactor) else true;
if (features.model = "{model}Fully configurable") then (((hd0.hdtype = "{pc.hd.hdtype}scsi") or (hd1.hdtype = "{pc.hd.hdtype}scsi") or (cddvd.hdtype = "{pc.cddvd.hdtype}scsi")) -> ((mb.scsionboard = "{pc.mb.scsionboard}1") or (scsictrl.id <> "1000005"))) else true;
if (features.model = "{model}Fully configurable") then ((mb.gconboard = "{pc.mb.gconboard}1") or (gc.id <> "1000015")) else true;
if (features.model = "{model}Fully configurable") then (loudspeakers.sound -> (mb.sound or soundcard.sound)) else true;
};

variable

  public  pc : Pc;

